/*a simple calculator for complex number system
 *Akira Saitoh (1999,2002,2015)
 *---------------------------------------------------------
 *References
 * [1] Eric Harlow: DEVELOPING LINUX APPLICATIONS by Eric Harlow (1999)
 * [2] Eiji Takeda: GTK+ de hajimeru X programming (1999)
 *
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif/*HAVE_CONFIG_H*/
#include "cgtkcalc.h"

/*When you change this list, you should also modify
 *`ButtonList.h'. it is used to define keyboard shortcuts.
 */
typCalculatorButton buttonList[] = {
{"Cut",0,0,1,OTHERS,NULL,0},     /*0*/
{"Copy",0,1,1,OTHERS,NULL,0},    /*1*/
{"ACP",0,2,1,OTHERS,NULL,0},     /*2*/
{"Paste",0,3,1,OTHERS,NULL,0},   /*3*/
{"Undo",0,4,1,OTHERS,NULL,0},    /*4*/
/*"DRPI" is also used in `Clicked.c'.*/
{"DRPI",0,5,1,OTHERS,NULL,0},    /*5*/
{"CE/C",0,6,1,OTHERS,NULL,0},    /*6*/
{"ACL",0,7,1,OTHERS,NULL,0},     /*7*/

/*Never change toggle buttons.*/
{"real",1,0,1,TOGGLE_B,NULL,0},  /*8*/
{"imag",1,4,1,TOGGLE_B,NULL,0},  /*9*/
{"abs",2,0,1,TOGGLE_B,NULL,0},   /*10*/
{"arg",2,4,1,TOGGLE_B,NULL,0},   /*11*/

{"Memo.",3,0,6,COVERS,NULL,0},   /*12*/
{"B.S.",3,6,2,OTHERS,NULL,0},    /*13*/
   
{"asinh",4,0,1,UNARY_OP,NULL,0}, /*14*/
{"acosh",4,1,1,UNARY_OP,NULL,0}, /*15*/
{"atanh",4,2,1,UNARY_OP,NULL,0}, /*16*/
{"asin",4,3,1,UNARY_OP,NULL,0},  /*17*/
{"acos",4,4,1,UNARY_OP,NULL,0},  /*18*/
{"atan",4,5,1,UNARY_OP,NULL,0},  /*19*/
{"re z",4,6,1,UNARY_OP,NULL,0},  /*20*/
{"im z",4,7,1,UNARY_OP,NULL,0},  /*21*/

{"sinh",5,0,1,UNARY_OP,NULL,0},  /*22*/
{"cosh",5,1,1,UNARY_OP,NULL,0},  /*23*/
{"tanh",5,2,1,UNARY_OP,NULL,0},  /*24*/
{"sin",5,3,1,UNARY_OP,NULL,0},   /*25*/
{"cos",5,4,1,UNARY_OP,NULL,0},   /*26*/
{"tan",5,5,1,UNARY_OP,NULL,0},   /*27*/
{"|z|",5,6,1,UNARY_OP,NULL,0},   /*28*/
{"arg z",5,7,1,UNARY_OP,NULL,0}, /*29*/

{"gamma",6,0,1,UNARY_OP,NULL,0}, /*30*/
{"log2",6,1,1,UNARY_OP,NULL,0},  /*31*/
{"log10",6,2,1,UNARY_OP,NULL,0}, /*32*/
{"ln",6,3,1,UNARY_OP,NULL,0},    /*33*/
{"exp",6,4,1,UNARY_OP,NULL,0},   /*34*/
{"conj",6,5,1,UNARY_OP,NULL,0},  /*35*/
{"mod",6,6,1,BINARY_OP,NULL,3},  /*36*/
{"z^w",6,7,1,BINARY_OP,NULL,1},  /*37*/

{"nHr",7,0,1,BINARY_OP,NULL,2},  /*38*/
{"nPr",7,1,1,BINARY_OP,NULL,2},  /*39*/
{"nCr",7,2,1,BINARY_OP,NULL,2},  /*40*/
{"!!",7,3,1,UNARY_OP,NULL,0},    /*41*/
{"(",7,4,1,BINARY_OP,NULL,0},    /*42*/
{")",7,5,1,BINARY_OP,NULL,4},    /*43*/
{"EE",7,6,1,DIGITS,NULL,0},      /*44*/
{"/",7,7,1,BINARY_OP,NULL,3},    /*45*/

{"STO",8,0,1,OTHERS,NULL,0},     /*46*/
{"RCL",8,1,1,OTHERS,NULL,0},     /*47*/
{"cbrt",8,2,1,UNARY_OP,NULL,0},  /*48*/
{"!",8,3,1,UNARY_OP,NULL,0},     /*49*/
{"7",8,4,1,DIGITS,NULL,0},       /*50*/
{"8",8,5,1,DIGITS,NULL,0},       /*51*/
{"9",8,6,1,DIGITS,NULL,0},       /*52*/
{"*",8,7,1,BINARY_OP,NULL,3},    /*53*/

{"M+",9,0,1,OTHERS,NULL,0},      /*54*/
{"M-",9,1,1,OTHERS,NULL,0},      /*55*/
{"sqrt",9,2,1,UNARY_OP,NULL,0},  /*56*/
{"z^3",9,3,1,UNARY_OP,NULL,0},   /*57*/
{"4",9,4,1,DIGITS,NULL,0},       /*58*/
{"5",9,5,1,DIGITS,NULL,0},       /*59*/
{"6",9,6,1,DIGITS,NULL,0},       /*60*/
{"-",9,7,1,BINARY_OP,NULL,4},    /*61*/

{"M*",10,0,1,OTHERS,NULL,0},      /*62*/
{"M/",10,1,1,OTHERS,NULL,0},      /*63*/
{"e",10,2,1,DIGITS,NULL,0},       /*64*/
{"z^2",10,3,1,UNARY_OP,NULL,0},   /*65*/
{"1",10,4,1,DIGITS,NULL,0},       /*66*/
{"2",10,5,1,DIGITS,NULL,0},       /*67*/
{"3",10,6,1,DIGITS,NULL,0},       /*68*/
{"+",10,7,1,BINARY_OP,NULL,4},    /*69*/

{"M^",11,0,1,OTHERS,NULL,0},     /*70*/
{"conjM",11,1,1,OTHERS,NULL,0},  /*71*/
{"pi",11,2,1,DIGITS,NULL,0},     /*72*/
{"1/z",11,3,1,UNARY_OP,NULL,0},  /*73*/
{"0",11,4,1,DIGITS,NULL,0},      /*74*/
{".",11,5,1,DIGITS,NULL,0},      /*75*/
{"+/-",11,6,1,DIGITS,NULL,0},    /*76*/
{"=",11,7,1,BINARY_OP,NULL,4},   /*77*/
 };
int nButtons = 78;

