/*a simple calculator for complex number system
 *Akira Saitoh (1999)
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif/*HAVE_CONFIG_H*/
#include "CreateLabels.h"
GtkWidget *labelRe;  GtkWidget *labelIm;
GtkWidget *labelAbs; GtkWidget *labelArg;
GtkWidget *event_boxRe;  GtkWidget *event_boxIm;
GtkWidget *event_boxAbs; GtkWidget *event_boxArg;
static void label_pressed (GtkWidget *widget,
                           GdkEvent  *event,
                           gpointer data);

/*Create widgets that look like LCD panels.*/
void CreateLabels (GtkWidget *table)
{
   GtkWidget *frame;
   
   frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    gtk_table_attach_defaults (GTK_TABLE (table),  frame,
                              1, 4, 1, 2);
    gtk_widget_show (frame);
    /*By using event_box, activate the LCD when clicked.*/
   event_boxRe = gtk_event_box_new();
    gtk_widget_set_events (event_boxRe, GDK_BUTTON_PRESS_MASK);
    gtk_signal_connect (GTK_OBJECT(event_boxRe), "button_press_event",
                        GTK_SIGNAL_FUNC (label_pressed), 
                        (gpointer) REAL);
    gtk_container_add (GTK_CONTAINER(frame), GTK_WIDGET(event_boxRe));
    gtk_widget_show (event_boxRe);
   labelRe = gtk_label_new ("0");
    gtk_misc_set_alignment (GTK_MISC (labelRe), 1, .5);
    gtk_container_add (GTK_CONTAINER(event_boxRe), GTK_WIDGET(labelRe));
    gtk_widget_show (labelRe);                           


   frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    gtk_table_attach_defaults (GTK_TABLE (table), frame,
                               5, 8, 1, 2);
    gtk_widget_show (frame);                           
   event_boxIm = gtk_event_box_new();
    gtk_widget_set_events (event_boxIm, GDK_BUTTON_PRESS_MASK);
    gtk_signal_connect (GTK_OBJECT(event_boxIm), "button_press_event",
                        GTK_SIGNAL_FUNC (label_pressed),
                        (gpointer) IMAG);
    gtk_container_add (GTK_CONTAINER(frame), GTK_WIDGET(event_boxIm));
    gtk_widget_show (event_boxIm);
   labelIm = gtk_label_new ("0");
    gtk_misc_set_alignment (GTK_MISC (labelIm), 1, .5);
    gtk_container_add (GTK_CONTAINER(event_boxIm), GTK_WIDGET(labelIm));
    gtk_widget_show (labelIm);                           


   frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    gtk_table_attach (GTK_TABLE (table), frame, 1, 4, 2, 3,
                      GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND,
                      0, 2);
    gtk_widget_show (frame);
   event_boxAbs = gtk_event_box_new();
    gtk_widget_set_events (event_boxAbs, GDK_BUTTON_PRESS_MASK);
    gtk_signal_connect (GTK_OBJECT(event_boxAbs), "button_press_event",
                        GTK_SIGNAL_FUNC (label_pressed),
                        (gpointer) ABSO);
    gtk_container_add (GTK_CONTAINER(frame), GTK_WIDGET(event_boxAbs));
    gtk_widget_show (event_boxAbs);
   labelAbs = gtk_label_new ("0");
    gtk_misc_set_alignment (GTK_MISC (labelAbs), 1, .5);
    gtk_container_add (GTK_CONTAINER(event_boxAbs), GTK_WIDGET(labelAbs));
    gtk_widget_show (labelAbs);          


   frame = gtk_frame_new (NULL);
    gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
    gtk_table_attach (GTK_TABLE (table), frame, 5, 8, 2, 3,
                      GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND,
                      0, 2);
    gtk_widget_show (frame);                           
   event_boxArg = gtk_event_box_new();
    gtk_widget_set_events (event_boxArg, GDK_BUTTON_PRESS_MASK);
    gtk_signal_connect (GTK_OBJECT(event_boxArg), "button_press_event",
                        GTK_SIGNAL_FUNC (label_pressed),
                        (gpointer) ARGU);
    gtk_container_add (GTK_CONTAINER(frame), GTK_WIDGET(event_boxArg));
    gtk_widget_show (event_boxArg);
   labelArg = gtk_label_new ("0");
    gtk_misc_set_alignment (GTK_MISC (labelArg), 1, .5);
    gtk_container_add (GTK_CONTAINER(event_boxArg), GTK_WIDGET(labelArg));
    gtk_widget_show (labelArg);

}
/*Called when the event_box is clicked,
 *set the part to input to the label on the event_box.*/
static void label_pressed (GtkWidget *widget,
                           GdkEvent  *event,
                           gpointer data)
{
   GtkWidget *l_button = NULL;
   switch ((gulong)data)
   {
      case REAL: l_button = buttonList[NB_REAL].widget; break;
      case IMAG: l_button = buttonList[NB_IMAG].widget; break;
      case ABSO: l_button = buttonList[NB_ABS].widget; break;
      case ARGU: l_button = buttonList[NB_ARG].widget; break;
      default: return;
   }
   gtk_widget_grab_focus (l_button);
   gtk_button_pressed (GTK_BUTTON (l_button));
   gtk_button_released (GTK_BUTTON (l_button));
}
