/*a simple calculator for complex number system
 *Akira Saitoh (1999-2017)
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif/*HAVE_CONFIG_H*/

#include "WindowIcon.h"

GdkPixbuf *icon_main = NULL;

void setup_window_icon (GtkWindow *w)
{
/*Note: For MINGW32, a window icon is retrieved in
 *      ../mingw32/cgtkcalc-mingw32.rc instead of this function.*/
#ifndef FOR_MINGW32 /*Non-MINGW32*/
#ifdef  HAVE_LIBGLIB_2_0 /*GTK+-2.0*/
  /*XPM icon data cgtkcalc_xpm is defined in cgtkcalc.xpm.*/
  #include "cgtkcalc.xpm" /*This is a static data.*/
  if (icon_main == NULL)
  {
    icon_main = gdk_pixbuf_new_from_xpm_data ((const char**)cgtkcalc_xpm);
  }
  gtk_window_set_icon(w, icon_main);
#endif /*GTK+-2.0*/
#endif /*Non-MINGW32*/
}

