/*cgtkcalc -- a simple calculator for complex number system
 *Akira Saitoh (1999,2002)
 */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif/*HAVE_CONFIG_H*/
#include <stdlib.h>
#include "cgtkcalc.h"
#include "WriteOutput.h"
#include "auxiliary.h"

/* Whether or not write operations to stdout. */
int var_write_ops = 0;

/*
   Create a string "a+bi" from labels on window.
   Specifying second parameter 'a' results in
   another format "a+bi = r ej theta".
   `buf' must have enough size F_BUF_SIZE.
*/
char *create_str_for_copy (char *buf, char fmt)
{
   char *ltext;

   gtk_label_get (GTK_LABEL (labelIm), &ltext);
   strcpy (buf, ltext);
   g_strchug (buf);
   if (atof(buf) == 0.0)
   {
      *buf = '\0';
   }
   else
   {
      if (*ltext == '-' || *(ltext+1) == '-')
      {
         str_plus (buf, "i");
      }
      else
      {
         plus_str ("+", buf);
         str_plus (buf, "i");
      }
   }
   gtk_label_get (GTK_LABEL (labelRe), &ltext);
   plus_str (ltext, buf);
   if (fmt == 'a')
   {
      str_plus (buf, " = ");
      gtk_label_get (GTK_LABEL (labelAbs), &ltext);
      str_plus (buf, ltext);
      str_plus (buf, " ej ");
      gtk_label_get (GTK_LABEL (labelArg), &ltext);
      str_plus (buf, ltext);
   }
   g_strchug (buf);
   return (buf); 
}

/* Write previous complex value and 
   str of current operation to stdout. */
void write_operation_stdout (_Sort_ sort, char *str)
{
   if (!var_write_ops) return;

   {
      char buf[F_BUF_SIZE] = "";

      if (str == NULL)
      {
         printf ("\t%s\n", create_str_for_copy (buf, ' '));
         return;
      }
      switch (sort)
      {
         case UNARY_OP:
            printf ("{unary:  %s(", str);
            printf ("%s)}\n", create_str_for_copy (buf, ' '));
            break;
         case BINARY_OP:
            if (*str == '(')
            {
               puts ("{parenthesis:\t(");
            }
            else
            {
               printf ("\t%s", create_str_for_copy (buf, ' '));
               printf ("\t%s\n", str);
            }
            if (*str == ')')
               puts (":parenthesis}");
            break;
         case OTHERS:
            printf ("{%s}\n", str);
            break;
         default:
            break;
      }
   }
}
